diff --git a/include/jit/jit-common.h b/include/jit/jit-common.h
index 9f0955e..072e4d2 100644
--- a/include/jit/jit-common.h
+++ b/include/jit/jit-common.h
@@ -78,6 +78,15 @@ typedef jit_nuint jit_label_t;
 #define	JIT_NO_OFFSET		(~((unsigned int)0))
 
 /*
+ * Functions used for the plugin memory manager for code memory.
+ */
+typedef void* (*jit_malloc_code_func)(unsigned long minimalsize, unsigned long* actual_size);
+typedef void  (*jit_resize_code_func)(void *data, unsigned long actual_size);
+typedef void  (*jit_free_code_func)(void *data);
+typedef void* (*jit_malloc_func)(unsigned long size);
+typedef void  (*jit_free_func)(void *data);
+
+/*
  * Function that is used to free user-supplied metadata.
  */
 typedef void (*jit_meta_free_func)(void *data);
diff --git a/include/jit/jit-context.h b/include/jit/jit-context.h
index ccb89d9..ff39f14 100644
--- a/include/jit/jit-context.h
+++ b/include/jit/jit-context.h
@@ -44,6 +44,11 @@ void *jit_context_get_meta(jit_context_t context, int type) JIT_NOTHROW;
 jit_nuint jit_context_get_meta_numeric
 	(jit_context_t context, int type) JIT_NOTHROW;
 void jit_context_free_meta(jit_context_t context, int type) JIT_NOTHROW;
+void jit_context_set_code_allocator(jit_context_t context,
+				    jit_malloc_code_func malloc_code_func, jit_resize_code_func resize_code_func, jit_free_code_func free_code_func,
+				    jit_malloc_func malloc_func, jit_free_func free_func);
+int jit_context_get_code_factor(jit_context_t context);
+void jit_context_update_code_factor(jit_context_t context, int code_factor);
 
 /*
  * Standard meta values for builtin configurable options.
diff --git a/include/jit/jit-function.h b/include/jit/jit-function.h
index e24271a..75cd4f0 100644
--- a/include/jit/jit-function.h
+++ b/include/jit/jit-function.h
@@ -37,6 +37,7 @@ jit_function_t jit_function_create_nested
 	(jit_context_t context, jit_type_t signature,
 	 jit_function_t parent) JIT_NOTHROW;
 void jit_function_abandon(jit_function_t func) JIT_NOTHROW;
+void jit_function_free(jit_function_t func) JIT_NOTHROW;
 jit_context_t jit_function_get_context(jit_function_t func) JIT_NOTHROW;
 jit_type_t jit_function_get_signature(jit_function_t func) JIT_NOTHROW;
 int jit_function_set_meta
diff --git a/include/jit/jit-insn.h b/include/jit/jit-insn.h
index e2631eb..c000128 100644
--- a/include/jit/jit-insn.h
+++ b/include/jit/jit-insn.h
@@ -216,6 +216,7 @@ jit_value_t jit_insn_address_of
 	(jit_function_t func, jit_value_t value1) JIT_NOTHROW;
 jit_value_t jit_insn_address_of_label
 	(jit_function_t func, jit_label_t *label) JIT_NOTHROW;
+int jit_insn_cast(jit_function_t func, jit_value_t value, jit_type_t type) JIT_NOTHROW;
 jit_value_t jit_insn_convert
 	(jit_function_t func, jit_value_t value,
 	 jit_type_t type, int overflow_check) JIT_NOTHROW;
diff --git a/jit/Makefile.am b/jit/Makefile.am
index 4dd0274..9a010d3 100644
--- a/jit/Makefile.am
+++ b/jit/Makefile.am
@@ -83,7 +83,7 @@ EXTRA_DIST = \
 
 AM_CFLAGS = -I$(top_srcdir)/include -I$(top_builddir)/include -I. -I$(srcdir)
 
-libjit_la_LDFLAGS = -version-info $(LIBJIT_VERSION) -no-undefined
+libjit_la_LDFLAGS = -shared -Wl,--kill-at,--output-def,libjit.def -version-info $(LIBJIT_VERSION) -no-undefined
 
 jit-interp.lo: jit-interp-labels.h
 
diff --git a/jit/jit-apply-x86-64.c b/jit/jit-apply-x86-64.c
index 895fccc..38f662b 100644
--- a/jit/jit-apply-x86-64.c
+++ b/jit/jit-apply-x86-64.c
@@ -487,13 +487,18 @@ _jit_classify_struct(jit_param_passing_t *passing,
 		}
 		if(arg_class == X86_64_ARG_INTEGER)
 		{
-			if(passing->word_index < passing->max_word_regs)
+#ifdef JIT_APPLY_ARG_REGISTERS_OVERLAP
+			int register_index = passing->word_index + passing->float_index;
+#else
+      int register_index = passing->word_index;
+#endif
+			if(register_index < passing->max_word_regs)
 			{
 				/* Set the arg class to the number of registers used */
 				param->arg_class = 1;
 
 				/* Set the first register to the register used */
-				param->un.reg_info[0].reg = passing->word_regs[passing->word_index];
+				param->un.reg_info[0].reg = passing->word_regs[register_index];
 				param->un.reg_info[0].value = param->value;
 				++(passing->word_index);
 			}
@@ -508,13 +513,18 @@ _jit_classify_struct(jit_param_passing_t *passing,
 		}
 		else if(arg_class == X86_64_ARG_SSE)
 		{
-			if(passing->float_index < passing->max_float_regs)
+#ifdef JIT_APPLY_ARG_REGISTERS_OVERLAP
+			int register_index = passing->word_index + passing->float_index;
+#else
+      int register_index = passing->float_index;
+#endif
+			if(register_index < passing->max_float_regs)
 			{
 				/* Set the arg class to the number of registers used */
 				param->arg_class = 1;
 
 				/* Set the first register to the register used */
-				param->un.reg_info[0].reg =	passing->float_regs[passing->float_index];
+				param->un.reg_info[0].reg =	passing->float_regs[register_index];
 				param->un.reg_info[0].value = param->value;
 				++(passing->float_index);
 			}
@@ -536,6 +546,7 @@ _jit_classify_struct(jit_param_passing_t *passing,
 			_jit_alloc_param_slot(passing, param, param_type);
 		}
 	}
+#ifdef JIT_APPLY_SPLIT_STRUCT_OVER_REGS
 	else if(size <= 16)
 	{
 		int arg_class1;
@@ -640,6 +651,7 @@ _jit_classify_struct(jit_param_passing_t *passing,
 			}
 		}
 	}
+#endif
 	else
 	{
 		/* Set the arg class to stack */
@@ -669,13 +681,18 @@ _jit_classify_param(jit_param_passing_t *passing,
 		{
 			case X86_64_ARG_INTEGER:
 			{
-				if(passing->word_index < passing->max_word_regs)
+#ifdef JIT_APPLY_ARG_REGISTERS_OVERLAP
+				int register_index = passing->word_index + passing->float_index;
+#else
+				int register_index = passing->word_index;
+#endif
+				if(register_index < passing->max_word_regs)
 				{
 					/* Set the arg class to the number of registers used */
 					param->arg_class = 1;
 
 					/* Set the first register to the register used */
-					param->un.reg_info[0].reg = passing->word_regs[passing->word_index];
+					param->un.reg_info[0].reg = passing->word_regs[register_index];
 					param->un.reg_info[0].value = param->value;
 					++(passing->word_index);
 				}
@@ -692,13 +709,18 @@ _jit_classify_param(jit_param_passing_t *passing,
 
 			case X86_64_ARG_SSE:
 			{
-				if(passing->float_index < passing->max_float_regs)
+#ifdef JIT_APPLY_ARG_REGISTERS_OVERLAP
+				int register_index = passing->word_index + passing->float_index;
+#else
+				int register_index = passing->float_index;
+#endif
+				if(register_index < passing->max_float_regs)
 				{
 					/* Set the arg class to the number of registers used */
 					param->arg_class = 1;
 
 					/* Set the first register to the register used */
-					param->un.reg_info[0].reg =	passing->float_regs[passing->float_index];
+					param->un.reg_info[0].reg =	passing->float_regs[register_index];
 					param->un.reg_info[0].value = param->value;
 					++(passing->float_index);
 				}
diff --git a/jit/jit-apply-x86-64.h b/jit/jit-apply-x86-64.h
index c2b452f..6138849 100644
--- a/jit/jit-apply-x86-64.h
+++ b/jit/jit-apply-x86-64.h
@@ -136,6 +136,9 @@ _jit_classify_struct(jit_param_passing_t *passing,
 
 #if defined(__GNUC__)
 
+#if !defined(__CYGWIN__) && !defined(__CYGWIN32__) && \
+	!defined(_WIN32) && !defined(WIN32)
+
 #ifndef	JIT_MEMCPY
 # if defined(__APPLE__) && defined(__MACH__)
 #  define JIT_MEMCPY "_jit_memcpy"
@@ -286,7 +289,278 @@ _jit_classify_struct(jit_param_passing_t *passing,
 		do { \
 		} while (0)
 
-#endif /* GNUC */
+#else /* Win64 */
+
+/*
+ * We have to add all registers not saved by the caller to the clobber list
+ * and not only the registers used for parameter passing because we call
+ * arbitrary functions.
+ * Maybe we should add the mmx* registers too?
+ */
+#define	jit_builtin_apply(func,args,size,return_float,return_buf)	\
+		do { \
+			void *__func = (void *)(func); \
+			void *__args = (void *)(args); \
+			jit_nint __size = (((jit_nint)(size) + (jit_nint)0xf) & ~(jit_nint)0xf); \
+			void *__return_buf = alloca(64); \
+			(return_buf) = __return_buf; \
+			__asm__ ( \
+				"movq %1, %%rax\n\t" \
+				"movq (%%rax), %%rdx\n\t" \
+				"movq %2, %%r8\n\t" \
+				"subq %%r8, %%rsp\n\t" \
+				"movq %%rsp, %%rcx\n\t" \
+				"callq _memcpy\n\t" \
+				"movq $0x20, %%rcx\n\t" \
+				"subq %%rcx, %%rsp\n\t" \
+				"movq %1, %%rax\n\t" \
+				"movq 0x08(%%rax), %%rcx\n\t" \
+				"movq 0x10(%%rax), %%rdx\n\t" \
+				"movq 0x18(%%rax), %%r8\n\t" \
+				"movq 0x20(%%rax), %%r9\n\t" \
+				"movaps 0x30(%%rax), %%xmm0\n\t" \
+				"movaps 0x40(%%rax), %%xmm1\n\t" \
+				"movaps 0x50(%%rax), %%xmm2\n\t" \
+				"movaps 0x60(%%rax), %%xmm3\n\t" \
+				"movq %0, %%r11\n\t" \
+				"callq *%%r11\n\t" \
+				"movq $0x20, %%rcx\n\t" \
+				"addq %%rcx, %%rsp\n\t" \
+				"movq %3, %%rcx\n\t" \
+				"movq %%rax, (%%rcx)\n\t" \
+				"movq %%rdx, 0x08(%%rcx)\n\t" \
+				"movaps %%xmm0, 0x10(%%rcx)\n\t" \
+				"movq %2, %%rcx\n\t" \
+				"addq %%rcx, %%rsp\n\t" \
+				: : "m"(__func), "m"(__args), "m"(__size), "m"(__return_buf) \
+				: "rax", "rcx", "rdx", "r8", "r9", \
+				  "r10", "r11", \
+				  "xmm0", "xmm1", "xmm2", "xmm3" \
+			); \
+			if((return_float)) \
+			{ \
+				__asm__ ( \
+					"movq %0, %%rax\n\t" \
+					"fstpt 0x20(%%rax)\n\t" \
+					: : "m"(__return_buf) \
+					: "rax", "st" \
+				); \
+			} \
+		} while (0)
+
+#define	jit_builtin_apply_args(type,args)	\
+		do { \
+			void *__args = alloca(192); \
+			__asm__ ( \
+				"pushq %%rdi\n\t" \
+				"leaq 16(%%rbp), %%rdi\n\t" \
+				"movq %0, %%rax\n\t" \
+				"movq %%rdi, (%%rax)\n\t" \
+				"popq %%rdi\n\t" \
+				"movq %%rdi, 0x08(%%rax)\n\t" \
+				"movq %%rsi, 0x10(%%rax)\n\t" \
+				"movq %%rdx, 0x18(%%rax)\n\t" \
+				"movq %%rcx, 0x20(%%rax)\n\t" \
+				"movq %%r8, 0x28(%%rax)\n\t" \
+				"movq %%r9, 0x30(%%rax)\n\t" \
+				"movaps %%xmm0, 0x40(%%rax)\n\t" \
+				"movaps %%xmm1, 0x50(%%rax)\n\t" \
+				"movaps %%xmm2, 0x60(%%rax)\n\t" \
+				"movaps %%xmm3, 0x70(%%rax)\n\t" \
+				"movaps %%xmm4, 0x80(%%rax)\n\t" \
+				"movaps %%xmm5, 0x90(%%rax)\n\t" \
+				"movaps %%xmm6, 0xA0(%%rax)\n\t" \
+				"movaps %%xmm7, 0xB0(%%rax)\n\t" \
+				: : "m"(__args) \
+				: "rax", "rcx", "rdx", "rdi", "rsi", "r8", "r9", \
+				  "xmm0", "xmm1", "xmm2", "xmm3", "xmm4", \
+				  "xmm5", "xmm6", "xmm7" \
+			); \
+			(args) = (type)__args; \
+		} while (0)
+
+#define	jit_builtin_return_int(return_buf)	\
+		do { \
+			__asm__ ( \
+				"lea %0, %%rcx\n\t" \
+				"movq (%%rcx), %%rax\n\t" \
+				"movq 0x08(%%rcx), %%rdx\n\t" \
+				"movaps 0x10(%%rcx), %%xmm0\n\t" \
+				: : "m"(*(return_buf)) \
+				: "rax", "rcx", "rdx", "xmm0" \
+			); \
+			return; \
+		} while (0)
+
+#define	jit_builtin_return_float(return_buf)	\
+		do { \
+			__asm__ ( \
+				"lea %0, %%rcx\n\t" \
+				"movaps 0x10(%%rcx), %%xmm0\n\t" \
+				: : "m"(*(return_buf)) \
+				: "rcx", "xmm0", "st" \
+			); \
+			return; \
+		} while (0)
+
+#define	jit_builtin_return_double(return_buf)	\
+		do { \
+			__asm__ ( \
+				"lea %0, %%rcx\n\t" \
+				"movaps 0x10(%%rcx), %%xmm0\n\t" \
+				: : "m"(*(return_buf)) \
+				: "rcx", "xmm0", "st" \
+			); \
+			return; \
+		} while (0)
+
+#define	jit_builtin_return_nfloat(return_buf)	\
+		do { \
+			__asm__ ( \
+				"lea %0, %%rcx\n\t" \
+				"fldt 0x20(%%rcx)\n\t" \
+				: : "m"(*(return_buf)) \
+				: "rcx", "xmm0", "st" \
+			); \
+			return; \
+		} while (0)
+
+#define jit_builtin_return_struct(return_buf, type) \
+		do { \
+		} while (0)
+    
+#endif /* Win32 */
+
+#elif defined(_MSC_VER)
+
+#define	jit_builtin_apply(func,args,size,return_float,return_buf)	\
+		do { \
+			void *__func = (void *)(func); \
+			void *__args = (void *)(args); \
+			void *__size = (((long)(size) + (long)0xf) & ~(long)0xf); \
+			void *__return_buf = alloca(64); \
+			(return_buf) = __return_buf; \
+			__asm { \
+				__asm movq rax, ptr __size \
+				__asm movq rsi, [rax] \
+				__asm movq rdx, ptr __args \
+				__asm subq rsp, rdx \
+				__asm movq rdi, rsp \
+				__asm callq jit_memcpy \
+				__asm movq rax, ptr __args \
+				__asm movq rdi, [rax + 0x08] \
+				__asm movq rsi, [rax + 0x10] \
+				__asm movq rdx, [rax + 0x18] \
+				__asm movq rcx, [rax + 0x20] \
+				__asm movq r8, [rax + 0x28] \
+				__asm movq r9, [rax + 0x30] \
+				__asm movaps xmm0, [rax + 0x40] \
+				__asm movaps xmm1, [rax + 0x50] \
+				__asm movaps xmm2, [rax + 0x60] \
+				__asm movaps xmm3, [rax + 0x70] \
+				__asm movaps xmm4, [rax + 0x80] \
+				__asm movaps xmm5, [rax + 0x90] \
+				__asm movaps xmm6, [rax + 0xA0] \
+				__asm movaps xmm7, [rax + 0xB0] \
+				__asm movq r11, ptr __func \
+				__asm movl eax, 8 \
+				__asm callq r11 \
+				__asm movq rcx, ptr __return_buf \
+				__asm movq [rcx], rax \
+				__asm movq [rcx +0x08], rdx \
+				__asm movaps [rcx +0x10], xmm0 \
+				__asm movq rdx, ptr __size \
+				__asm addq rsp, rdx \
+			} \
+			if((return_float)) \
+			{ \
+				__asm { \
+          /* \
+					__asm mov ecx, dword ptr __return_buf \
+					__asm fstpl [ecx + 8] \
+					__asm _emit 0xDD \
+					__asm _emit 0x59 \
+					__asm _emit 0x08 \
+          */ \
+					__asm movq rax, ptr __return_buf \
+					__asm fstpt [rax + 0x20] \
+				} \
+			} \
+		} while (0)
+
+#define	jit_builtin_apply_args(type,args)	\
+		do { \
+			void *__args = alloca(192); \
+			__asm { \
+				__asm pushq rdi \
+				__asm leaq rdi, [rbp + 16] \
+				__asm movq rax, ptr __args \
+				__asm movq [rax], rdi \
+				__asm popq rdi \
+				__asm movq [rax + 0x08], rdi \
+				__asm movq [rax + 0x10], rsi \
+				__asm movq [rax + 0x18], rdx \
+				__asm movq [rax + 0x20], rcx \
+				__asm movq [rax + 0x28], r8 \
+				__asm movq [rax + 0x30], r9 \
+				__asm movaps [rax + 0x40], xmm0 \
+				__asm movaps [rax + 0x50], xmm1 \
+				__asm movaps [rax + 0x60], xmm2 \
+				__asm movaps [rax + 0x70], xmm3 \
+				__asm movaps [rax + 0x80], xmm4 \
+				__asm movaps [rax + 0x90], xmm5 \
+				__asm movaps [rax + 0xA0], xmm6 \
+				__asm movaps [rax + 0xB0], xmm7 \
+			} \
+			(args) = (type)(__args); \
+		} while (0)
+
+#define	jit_builtin_return_int(return_buf)	\
+		do { \
+			void *__return_buf = (void *)(return_buf); \
+			__asm { \
+				__asm lea rcx, ptr __return_buf \
+				__asm movq rax, [rcx] \
+				__asm movq rdx, [rcx + 0x08] \
+				__asm movaps xmm0, [rcx + 0x10] \
+			} \
+			return; \
+		} while (0)
+
+#define	jit_builtin_return_float(return_buf)	\
+		do { \
+			void *__return_buf = (void *)(return_buf); \
+			__asm { \
+				__asm lea rcx, ptr __return_buf \
+				__asm movaps xmm0, [rcx + 0x10] \
+			} \
+			return; \
+		} while (0)
+
+#define	jit_builtin_return_double(return_buf)	\
+		do { \
+			void *__return_buf = (void *)(return_buf); \
+			__asm__ ( \
+				__asm lea rcx, ptr __return_buf \
+				__asm movaps xmm0, [rcx + 0x10] \
+			} \
+			return; \
+		} while (0)
+
+#define	jit_builtin_return_nfloat(return_buf)	\
+		do { \
+			__asm { \
+				__asm lea rcx, ptr __return_buf \
+				__asm fldt [rcx + 0x20] \
+			} \
+			return; \
+		} while (0)
+
+#define jit_builtin_return_struct(return_buf, type) \
+		do { \
+		} while (0)
+
+#endif /* MSC_VER */
 
 /*
  * The maximum number of bytes that are needed to represent a closure,
